package jp.co.ois.sample.batch.process;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import javax.annotation.PreDestroy;

import org.springframework.batch.item.ItemReader;

import jp.co.ois.sample.batch.model.HogeLine;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class HogeReader implements ItemReader<HogeLine> {

    String fileName;
    int lineNo = 0;
    BufferedReader fr;

    public HogeReader(String fn) throws IOException {
        log.debug("called. {}", fn);
        this.fileName = fn;
        fr = new BufferedReader(new FileReader(fileName));
    }

    @Override
    public HogeLine read() throws IOException {
        log.debug("called. {}", lineNo);
        String line = fr.readLine();
        if (line == null) return null;
        lineNo++;
        return new HogeLine(line);
    }

    @PreDestroy
    public void close() throws IOException {
        log.debug("called.");
        fr.close();
    }
}
